SystemOrganization addCategory: #'MinimalConnectors-Connections'!

!Bezier2Segment methodsFor: '*MinimalConnectors-Connections' stamp: 'nk 8/23/2003 13:54'!
controlPoints
	^{start. via. end}! !

!Bezier2Segment methodsFor: '*MinimalConnectors-Connections' stamp: 'nk 8/18/2003 11:29'!
controlPointsDo: aBlock
	aBlock value: start; value: via; value: end! !

!Bezier2Segment methodsFor: '*MinimalConnectors-Connections' stamp: 'FernandoOlivero 4/13/2010 23:54'!
intersectionsWithLineFrom: e1 to: e2
	"Answer the set of intersections, if any"
	| retval l i |
	retval := OrderedCollection new: 2.
	l := LineSegment from: e1 to: e2.
	self lineSegmentsDo: [ :p1 :p2 | | s |
		s := LineSegment from: p1 to: p2.
		i := s intersectionWith: l.
		i ifNotNil: [ retval add: i ].
		retval size = 2 ifTrue: [ ^retval asArray ].
	].
	^retval asArray! !

!Bezier2Segment methodsFor: '*MinimalConnectors-Connections' stamp: 'FernandoOlivero 4/13/2010 23:54'!
lineSegmentsWithParametricValueDo: aBlock
	"Evaluate aBlock with the receiver's line segments and the corresponding parametric values, ranging from just above 0 to 1.0"
	"Note: We could use forward differencing here."
	| steps last deltaStep t lastT next |
	steps := 1 max: (self length // 10). "Assume 10 pixels per step"
	last := start.
	deltaStep := 1.0 / steps asFloat.
	t := deltaStep.
	lastT := 0.0.
	1 to: steps do:[:i|
		next := self valueAt: t.
		aBlock value: last value: next value: lastT value: t.
		last := next.
		lastT := t.
		t := t + deltaStep].! !

!Bezier2Segment methodsFor: '*MinimalConnectors-Connections' stamp: 'FernandoOlivero 4/13/2010 23:54'!
roundTo: quantum
	super roundTo: quantum.
	via := via roundTo: quantum.
! !

Morph subclass: #DiagramWhiteboard
	instanceVariableNames: 'model diagramNodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MinimalConnectors-Connections'!

!DiagramWhiteboard methodsFor: 'accessing' stamp: 'carlaGriggio 11/30/2010 15:10'!
allConnectedMorphs
	^self diagramNodeMorphs! !

!DiagramWhiteboard methodsFor: 'accessing' stamp: 'carlaGriggio 11/30/2010 15:10'!
allConnections
	^self connections! !

!DiagramWhiteboard methodsFor: 'positioning' stamp: 'carlaGriggio 10/26/2010 01:22'!
availablePositions
	^ (self positionedDiagramNodes 
		ifEmpty: [ Set with: "self center" 50@50 ] 
		ifNotEmpty: [self positionedDiagramNodes	inject: OrderedCollection new into:[:points :node | points union: (self neighborsFor: node position) ]
			])
			 select:[:point | self diagramNodes allSatisfy: [:node | node position ~= point]]! !

!DiagramWhiteboard methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/19/2010 08:58'!
connections
	^self submorphs inject: OrderedCollection new into:[:rels :box | rels union: box connections ].! !

!DiagramWhiteboard methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/16/2010 13:14'!
diagram
	^self model! !

!DiagramWhiteboard methodsFor: 'accessing' stamp: 'carlaGriggio 12/1/2010 23:42'!
diagramNodeMorphFor: aDiagramNodeDescription
	^diagramNodes at: aDiagramNodeDescription ifAbsentPut: [aDiagramNodeDescription view]! !

!DiagramWhiteboard methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 02:30'!
diagramNodeMorphs
	^ self diagramNodes collect:[:boxDesc | (self diagramNodeMorphFor: boxDesc) diagramNode: boxDesc  ]! !

!DiagramWhiteboard methodsFor: 'accessing' stamp: 'carlaGriggio 8/20/2010 02:30'!
diagramNodes
	^self model diagramNodes! !

!DiagramWhiteboard methodsFor: 'accessing' stamp: 'carlaGriggio 8/1/2010 17:10'!
displayString
	^self name! !

!DiagramWhiteboard methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/2/2010 14:48'!
initialize
	super initialize.
	self fillStyle: Color white.
	self dropEnabled: true.
	self extent: 500@500.
	self clipSubmorphs: false.! !

!DiagramWhiteboard methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 8/6/2010 22:53'!
model 
	^model ! !

!DiagramWhiteboard methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/16/2010 13:14'!
model: anObject
	model := anObject.
	model ifNotNil: [
		self diagram removeDependent: self.].
	anObject ifNotNil: [
		self diagram addDependent: self. ].
	diagramNodes := Dictionary new.

! !

!DiagramWhiteboard methodsFor: 'positioning' stamp: 'carlaGriggio 10/26/2010 01:30'!
neighborsFor: aPoint 
|delta|
delta := 150.

	^ (Array with: aPoint + (delta @ 0)
		with: aPoint + (0 @ delta)
		with: aPoint - (delta @ 0)
		with: aPoint - (0 @ delta)) select:[:point | self containsPoint: point + self position]
! !

!DiagramWhiteboard methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 10/24/2010 19:45'!
positionDiagramNodes
|bannedPositions|
bannedPositions := Set new.
	self diagramNodes do:[:node |
		node position ifNil:[
			self positionNode: node.
"			[((self positionedDiagramNodes reject:[:n | n = node]) anySatisfy: [:n| n view intersects: node view bounds])] whileTrue:
				[bannedPositions add: node position.
						self positionNode: node]"]]! !

!DiagramWhiteboard methodsFor: 'positioning' stamp: 'carlaGriggio 10/26/2010 01:33'!
positionNode: aNode
	aNode position: self availablePositions anyOne.! !

!DiagramWhiteboard methodsFor: 'positioning' stamp: 'carlaGriggio 10/24/2010 18:21'!
positionedDiagramNodes
	^self diagramNodes select:[:node | node position notNil]! !

!DiagramWhiteboard methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/17/2010 02:19'!
update
	self removeAllMorphs.
	diagramNodes := Dictionary new.
	self positionDiagramNodes.
	self diagramNodeMorphs" do: [:classBoxMorph | classBoxMorph updateRelationships  ]".
	diagramNodes keysAndValuesDo: [:classBoxDescription :classBoxMorph | 
		(classBoxDescription relations" difference: classBoxMorph connections") do:[:relation | 
			relation view fitIntoDiagram:self ]].

	self addAllMorphs: (self diagramNodeMorphs difference: submorphs ). 
	self diagramNodeMorphs do: #adjustPosition.
	
	self diagramNodeMorphs do: [:classBoxMorph | classBoxMorph updateBounds  ].
	self bounds: self fullBounds.
	self position: 0@0.
	self connections do: #updateView.
	self connections do: #updateLabel.
	"owner ifNil:[self bounds: self fullBounds] ifNotNil:[self bounds: owner bounds].
"
	! !

!DiagramWhiteboard methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 11/12/2010 20:59'!
update: aParameter
	(aParameter == #view) 
		ifTrue:[self update.].
! !

!DiagramWhiteboard methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 9/2/2010 09:08'!
updateDescriptionCode 
	self model update: #descriptionCode.! !

!DiagramWhiteboard methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/17/2010 04:25'!
updateRelationships
		
		self diagramNodeMorphs do: #resetBoundings.
		self connections do:[:rel | rel fitIntoDiagram: self].
		self diagramNodeMorphs do: #updateBounds.! !

BorderedMorph subclass: #ConnectionMorph
	instanceVariableNames: 'lineWidth smoothCurve vertices segments contours arrows arrowForms arrowScales arrowJoints connectionPoints type borderDashSpec'
	classVariableNames: 'ArrowGlyphs'
	poolDictionaries: ''
	category: 'MinimalConnectors-Connections'!

!ConnectionMorph class methodsFor: 'arrows' stamp: 'FernandoOlivero 4/14/2010 15:20'!
arrowDictionary
	^ArrowGlyphs ifNil: [
		ArrowGlyphs := Dictionary new.
		self initializeArrowDictionary ].! !

!ConnectionMorph class methodsFor: 'arrow forms' stamp: 'FernandoOlivero 5/18/2010 14:31'!
basicArrow
	^ NCLineArrowGlyph  basicArrow1  ! !

!ConnectionMorph class methodsFor: 'arrows' stamp: 'FernandoOlivero 4/14/2010 15:20'!
clearArrowDictionary
	ArrowGlyphs ifNil: [ ^ArrowGlyphs := Dictionary new ].
	ArrowGlyphs keysAndValuesRemove: [ :k :v | true ];
		changed: #arrowsChanged.
! !

!ConnectionMorph class methodsFor: 'arrow forms' stamp: 'nk 8/20/2003 10:26'!
defaultArrow
	^NCLineArrowGlyph noArrow! !

!ConnectionMorph class methodsFor: 'instance creation' stamp: 'FernandoOlivero 5/31/2011 13:15'!
defaultConnection
	| m |
	m := self new.
	m
		initializeWithVertices:  (Array 
				with: 5 @ 0
				with: 200 @ 100
				with: 0 @ 200)
		lineWidth: 2
		lineColor: Color black  
		borderStyle: ( BorderStyle width: 1 color: Color black ).
	^ m
		
		! !

!ConnectionMorph class methodsFor: 'instance creation' stamp: 'FernandoOlivero 5/31/2011 12:59'!
example
	^ self newWithArrow
! !

!ConnectionMorph class methodsFor: 'instance creation' stamp: 'FernandoOlivero 5/31/2011 13:14'!
from: startConnectionPoint to: stopConnectionPoint 
	^self defaultConnection from: startConnectionPoint to: stopConnectionPoint
! !

!ConnectionMorph class methodsFor: 'class initialization' stamp: 'FernandoOlivero 4/14/2010 15:21'!
initialize
	self initializeArrowDictionary.! !

!ConnectionMorph class methodsFor: 'arrows' stamp: 'FernandoOlivero 4/14/2010 16:52'!
initializeArrowDictionary
	
	ArrowGlyphs ifNil: [ ArrowGlyphs := Dictionary new ].

	(self class organization listAtCategoryNamed: 'arrow forms') do: [ :sym |
		ArrowGlyphs at: sym put: (self perform: sym) ].

	(NCLineArrowGlyph class organization  listAtCategoryNamed: 'arrow forms') do: [ :sym |
		ArrowGlyphs at: sym put: (NCLineArrowGlyph perform: sym) ].
	
	ArrowGlyphs changed: #arrowsChanged.

	^ArrowGlyphs
! !

!ConnectionMorph class methodsFor: 'arrows' stamp: 'FernandoOlivero 4/14/2010 15:20'!
nameForArrowGlyph: anArrow
	self arrowDictionary keysAndValuesDo: [ :key :value |
		anArrow originalFirstContour = value originalFirstContour
			ifTrue: [ ^key ].
	].
	^#unknown! !

!ConnectionMorph class methodsFor: 'instance creation-UML' stamp: 'FernandoOlivero 4/14/2010 15:24'!
newAssociation
	^self new
		name: 'Association'! !

!ConnectionMorph class methodsFor: 'instance creation' stamp: 'FernandoOlivero 5/31/2011 13:13'!
newCurvyArrow
	^ self defaultConnection
		beSmoothCurve;
		name: 'Curvy ConnectorArrow';
		arrowNames: #(#noArrow #basicArrow )! !

!ConnectionMorph class methodsFor: 'instance creation' stamp: 'FernandoOlivero 5/31/2011 13:14'!
newCurvyConnector
	^ self defaultConnection
		beSmoothCurve;
		name: 'Curvy Connector';
		arrowNames: #(#noArrow #noArrow )! !

!ConnectionMorph class methodsFor: 'instance creation-UML' stamp: 'FernandoOlivero 4/14/2010 15:24'!
newDirectionalAssociation
	^(self new)
		name: 'Association';
		arrowNames: #(noArrow umlArrow)! !

!ConnectionMorph class methodsFor: 'instance creation-UML' stamp: 'FernandoOlivero 4/14/2010 15:24'!
newGeneralizationRelationship

	^(self new) 
		arrowNames: #(noArrow openArrow);
		name: 'Generalization'! !

!ConnectionMorph class methodsFor: 'instance creation-UML' stamp: 'FernandoOlivero 4/15/2010 12:33'!
newHierarchyAssociation
	^(self new)
		name: 'Association';
		arrowNames: #(noArrow umlArrow)! !

!ConnectionMorph class methodsFor: 'instance creation-UML' stamp: 'FernandoOlivero 4/14/2010 15:24'!
newImplementationRelationship
	^self newGeneralizationRelationship
		dashedLine: true;
		name: 'Implements'! !

!ConnectionMorph class methodsFor: 'instance creation-UML' stamp: 'FernandoOlivero 4/15/2010 12:33'!
newInheritanceAssociation
	^(self new)
		name: 'Inheritance';
		arrowNames: #(noArrow umlArrow)! !

!ConnectionMorph class methodsFor: 'instance creation-UML' stamp: 'FernandoOlivero 4/14/2010 15:24'!
newNoteConnector
	^self new
		dashedLine: true;
		lineWidth: 1;
		name: 'Note Connector';
		connectToNearestPointToCenter.! !

!ConnectionMorph class methodsFor: 'instance creation-UML' stamp: 'FernandoOlivero 4/14/2010 15:25'!
newStateTransition
	^self new
		arrowNames: #(noArrow basicArrow);
		name: 'Transition'! !

!ConnectionMorph class methodsFor: 'instance creation' stamp: 'FernandoOlivero 5/31/2011 13:14'!
newWithArrow
	^ self defaultConnection
		name: 'Arrow';
		arrowNames: #(#noArrow #basicArrow )! !

!ConnectionMorph class methodsFor: 'arrow forms' stamp: 'FernandoOlivero 4/14/2010 15:20'!
noArrow
	^NCLineArrowGlyph noArrow! !

!ConnectionMorph class methodsFor: 'arrow forms' stamp: 'FernandoOlivero 5/18/2010 14:31'!
openArrow
	^ NCLineArrowGlyph openArrow.! !

!ConnectionMorph class methodsFor: 'testing' stamp: 'FernandoOlivero 4/14/2010 15:38'!
showSamples
	"
	self showSamples
	"
	| pum line offset verts |
	pum := PasteUpMorph new bounds: (0@0 corner: 560@900).
	pum openInWorld.
	0 to: 10 do: [ :lw |
		0 to: 3 do: [ :bw |
			{true. false} do: [ :sc |
				offset := ((bw * 100) + 20) @ ((lw * 80) + 20).
				sc ifTrue: [ offset := offset + (0@ 40) ].
				verts := { offset . offset + (40@20). offset + (80@0) }.
				line := self vertices: verts
					lineWidth: (lw/4) + 0.25
					lineColor: Color blue
					borderStyle: (BorderStyle simple width:bw;color: Color black ).
				sc ifTrue: [ line beSmoothCurve ].
				pum addMorph: line
			]
		]
	]
		! !

!ConnectionMorph class methodsFor: 'arrow forms' stamp: 'FernandoOlivero 5/18/2010 14:31'!
umlArrow
	^ NCLineArrowGlyph umlArrow ! !

!ConnectionMorph class methodsFor: 'instance creation' stamp: 'FernandoOlivero 5/31/2011 13:09'!
vertices: verts lineWidth: w lineColor: c borderStyle: aBorderStyle 
	| m |
	m := self new.
	m initializeWithVertices: verts lineWidth: w lineColor: c borderStyle: aBorderStyle.
	^ m
		
		! !

!ConnectionMorph methodsFor: 'drawing' stamp: 'nk 8/4/2003 18:55'!
areasRemainingToFill: aRectangle
	^ { aRectangle }! !

!ConnectionMorph methodsFor: 'arrows' stamp: 'nk 8/21/2003 17:11'!
arrowContours
	^{ contours fourth. contours second }! !

!ConnectionMorph methodsFor: 'arrows' stamp: 'FernandoOlivero 4/12/2010 00:40'!
arrowForms
	arrowForms ifNotNil: [ ^arrowForms ].
	arrowForms := self arrowContours withIndexCollect: [ :ac :aci | | form rect ext offset ji |
		rect := (Rectangle encompassing: ac) rounded.
		ext := rect extent max: 4@4.
		form := Form extent: rect extent depth: 1.
		ji := (arrows at: aci) joinIndex.
		((BalloonCanvas on: form) asShadowDrawingCanvas: Color black)
			transformBy: (MatrixTransform2x3 withOffset: rect origin negated)
			during: [ :canvas |
				canvas aaLevel: 4; deferred: true.
				canvas 
					drawGeneralBezierShape: { { ac at: ji. ac at: ji. ac first }. ac}
					color: Color black
					borderWidth: 1
					borderColor: Color black.
				canvas flush.
			].
		form offset: rect origin
	].
	^arrowForms! !

!ConnectionMorph methodsFor: 'arrows' stamp: 'FernandoOlivero 4/12/2010 00:40'!
arrowJoints
	^arrowJoints ifNil: [ arrowJoints := { vertices first. vertices last } ].! !

!ConnectionMorph methodsFor: 'arrows' stamp: 'FernandoOlivero 4/14/2010 16:48'!
arrowNames: anArray
	"anArray has the keys into my arrow dictionary for the desired arrows"
	self arrows: (anArray collect: [ :ea | self class arrowDictionary at: ea ifAbsent: [ nil ]])! !

!ConnectionMorph methodsFor: 'arrows' stamp: 'nk 8/24/2003 17:31'!
arrowScales
	"Answer the arrow scales relative to my linewidth"
	^arrowScales ifNil: [ { 1.0@1.0. 1.0@1.0 }].! !

!ConnectionMorph methodsFor: 'arrows' stamp: 'nk 10/21/2003 10:54'!
arrowScales: aScalarOrArray 
	"Change the arrow scales relative to my linewidth"
	
	arrowScales := (aScalarOrArray isCollection
		ifFalse: [ Array new: 2 withAll: aScalarOrArray ]
		ifTrue: [ Array withAll: aScalarOrArray ]) replaceAll: 0.0 with: 0.00001.
	self arrows: self arrows.! !

!ConnectionMorph methodsFor: 'arrows' stamp: 'FernandoOlivero 4/12/2010 00:40'!
arrowVertices
	"Answer my vertices, but with the first and last point from arrowJoints"
	| retval |
	retval := vertices collect: [ :v | v asFloatPoint ].
	retval at: 1 put: self arrowJoints first.
	retval at: retval size put: self arrowJoints second.
	^retval! !

!ConnectionMorph methodsFor: 'arrows' stamp: 'FernandoOlivero 4/12/2010 00:40'!
arrows
	^arrows ifNil: [ arrows := self arrows: {nil. nil} ].! !

!ConnectionMorph methodsFor: 'arrows' stamp: 'FernandoOlivero 4/12/2010 00:40'!
arrows: anArray
	"Given a pair of NCLineArrowGlyph instances at any scale,
	scale them proportionally to my line width and save copies."
	| newArrows |
	newArrows := (anArray with: self arrowScales collect: [ :ea :scale | | arrow min |
		arrow := (ea ifNil: [ self class defaultArrow ]) veryDeepCopy.
		min := 2.0@2.0 / (arrow bounds extent  / arrow scale).
		arrow scale: ((scale asPoint * self fullLineWidth) max: min); yourself ]).
	arrowForms ifNotNilDo: [ :fs |
		fs do: [ :f | f ifNotNil: [ self invalidRect: (f offset extent: f extent) ] ]].
	arrows := newArrows.
	arrowForms := nil.
	self computeBounds.
	^arrows! !

!ConnectionMorph methodsFor: 'geometry testing' stamp: 'nk 8/21/2003 17:41'!
arrowsContainPoint: aPoint
	"Answer an Array of two Booleans that indicate whether the given point is inside either arrow"
	^self arrowForms collect: [:f | (f pixelValueAt: aPoint - f offset) > 0 ].
! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'nk 7/18/2003 15:48'!
beSmoothCurve
	self isCurve ifFalse: [
		smoothCurve := true.
		self computeBounds]! !

!ConnectionMorph methodsFor: 'appearance' stamp: 'FernandoOlivero 4/14/2010 16:46'!
beSmoothCurve: aBoolean
	aBoolean
		ifTrue: [ self beSmoothCurve ]
		ifFalse: [ self beStraightSegments ]
! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 4/12/2010 00:40'!
beStraightSegments

	self isCurve ifTrue: [
		smoothCurve := false.
		self computeBounds]! !

!ConnectionMorph methodsFor: 'geometry-curves' stamp: 'nk 8/19/2003 10:34'!
bezierPoints
	"Answer nVertices*3 points that are the control points for my bezier curves."

	| pts i |
	pts := Array new: self segments size * 3.
	i := 1.
	self bezierSegmentsDo: 
			[:seg | 
			pts
				at: i put: seg start;
				at: i + 1 put: seg via;
				at: i + 2 put: seg end.
			i := i + 3].
	^pts! !

!ConnectionMorph methodsFor: 'geometry-curves' stamp: 'nk 8/18/2003 17:55'!
bezierSegmentsDo: segmentBlock 
	"Emit a sequence of LineSegment subinstances into segmentBlock"
	self segmentsDo: [ :s | segmentBlock value: s asBezier2Segment ]! !

!ConnectionMorph methodsFor: 'testing' stamp: 'nk 9/22/2003 14:49'!
canDrawBorder: aBorderStyle
	^aBorderStyle style == #simple! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 4/20/2010 09:17'!
close 
	connectionPoints do:[:each| each dettachFrom: self ].
	self delete.! !

!ConnectionMorph methodsFor: 'geometry testing' stamp: 'FernandoOlivero 4/12/2010 00:40'!
closestPointTo: aPoint
	| curveInfo |
	curveInfo := self curveInfoNearest: aPoint.
	^curveInfo closestPoint.! !

!ConnectionMorph methodsFor: 'geometry testing' stamp: 'nk 8/19/2003 10:33'!
closestSegmentTo: aPoint
	"Answer the starting index of my (big) segment nearest to aPoint"
	^(self curveInfoNearest: aPoint) closestBigSegment! !

!ConnectionMorph methodsFor: 'geometry' stamp: 'nk 12/28/2003 16:53'!
computeBounds
	| oldFullBounds oldBounds delta |
	vertices ifNil: [^self].
	oldFullBounds := (fullBounds ifNil: [bounds]) copy.
	contours := Array new: 4 withAll: #().
	self updateArrowContours.
	segments := self computeSegments.
	segments do: [:ea | ea roundTo: 0.001].
	arrowForms := nil.
	self computeContours.
	oldBounds := bounds.
	bounds := self curveBounds truncated.
	self arrowForms 
		do: [:af | bounds := bounds quickMerge: (af offset extent: af extent)].

	"since we are directly updating bounds,
	see if any ordinary submorphs exist and move them accordingly"
	submorphs isEmpty 
		ifFalse: 
			[(oldBounds notNil 
				and: [(delta := bounds origin - oldBounds origin) ~= (0 @ 0)]) 
					ifTrue: [self submorphsDo: [:each | each position: each position + delta]]].
	self invalidRect: oldFullBounds.
	self layoutChanged.
	self changed! !

!ConnectionMorph methodsFor: 'geometry-curves' stamp: 'FernandoOlivero 4/12/2010 00:40'!
computeContours
	| sides csize |
	(vertices size = 2 and: [vertices first = vertices second]) 
		ifTrue: [^contours := #()].
	true "(self lineWidth > 2 or: [self isCurve]) "
		ifTrue: [sides := self outsidePoints	"sideA, sideB reversed"]
		ifFalse: 
			[| bpts |
			bpts := self bezierPoints.
			sides := { 
						bpts.
						bpts reversed}].
	contours
		at: 1 put: sides first;
		at: 3 put: sides second.
	csize := contours first size.
	(contours at: 3)
		at: csize put: contours fourth first;
		at: 1 put: (contours second at: arrows second joinIndex).
	(contours at: 1)
		at: 1 put: (contours fourth at: arrows first joinIndex);
		at: csize put: contours second first.
	contours := contours collect: [ :ctr | ctr collect: [ :pt | pt roundTo: 0.001 ]].
	^contours! !

!ConnectionMorph methodsFor: 'geometry-curves' stamp: 'FernandoOlivero 4/12/2010 00:40'!
computeSegments
	| segs v3 l1 l2 m1 m2 lastUsed end arrowVertices |
	arrowVertices := self arrowVertices.
	arrowVertices size = 2 
		ifTrue: 
			[^{ LineSegment 
					from: arrowVertices first
					to: arrowVertices last }].

	smoothCurve ifFalse: [
		segs := Array new: arrowVertices size - 1.
		arrowVertices overlappingPairsWithIndexDo:  [ :v1 :v2 :i |
			segs at: i put: (LineSegment from: v1 to: v2)
		].
		^segs
	].

	segs := OrderedCollection new.
	lastUsed := arrowVertices first.
	2 to: arrowVertices size - 1 do:  [:i | | v2 symmetry |
			v2 := (arrowVertices at: i).
			v3 := (arrowVertices at: i + 1).
			l1 := lastUsed dist: v2.
			l2 := v2 dist: v3.
			symmetry := l1 - l2.
			symmetry < 0
				ifTrue: 
					[m1 := (lastUsed + v2) / 2.0.
					end := v2 interpolateTo: v3 at: l1 / l2 * 0.5.
					lastUsed ~= m1 
						ifTrue: 
							[segs add: (LineSegment 
										from: lastUsed
										to: m1)].
					segs add: (Bezier2Segment 
								from: m1
								to: end
								via: v2).
					lastUsed := end]
		ifFalse: [ m2 := (v2 + v3) / 2.0.
					end := v2 interpolateTo: lastUsed at: l2 / l1 * 0.5.
					lastUsed ~= end 
						ifTrue: 
							[segs add: (LineSegment 
										from: lastUsed
										to: end)].
					segs add: (Bezier2Segment 
								from: end
								to: m2
								via: v2).
					lastUsed := m2]
		].
	lastUsed ~= v3 
		ifTrue: 
			[segs add: (LineSegment 
						from: lastUsed
						to: v3)].
	^segs asArray ! !

!ConnectionMorph methodsFor: 'connecting' stamp: 'FernandoOlivero 4/20/2010 09:03'!
connectionPoints: aCollection 
	connectionPoints at: 1 put: aCollection first .
	connectionPoints at:2 put: aCollection second  .! !

!ConnectionMorph methodsFor: 'geometry testing' stamp: 'nk 9/28/2003 17:46'!
containsPoint: aPoint
	(super containsPoint: aPoint) ifFalse: [^ false].
	(self hasProperty: #errorOnDraw) ifTrue: [^true].
	
	(self arrowForms anySatisfy: [:f |
		 "(f pixelValueAt: aPoint - f offset) > 0"
		(Rectangle origin: f offset extent: f extent) containsPoint: aPoint
	 ])
		ifTrue: [^true ].

	self lineSegmentsDo:
		[:p1 :p2 |
		(aPoint onLineFrom: p1 to: p2 within: (10 max: (self fullLineWidth + 4) / 2))
				ifTrue: [^ true]].
			
	^ false! !

!ConnectionMorph methodsFor: 'geometry-curves' stamp: 'nk 8/23/2003 11:09'!
contourPoints
	"Answer my contours flattened as a series of points."

	^Array streamContents: [ :s |
		self contours do: [ :c | s nextPutAll: c ]]! !

!ConnectionMorph methodsFor: 'geometry-curves' stamp: 'nk 8/23/2003 11:10'!
contours
	contours ifNotNil: [^contours].
	(vertices size = 2 and: [vertices first = vertices second]) 
		ifTrue: [^contours := #()].
	self error: 'should be set'.! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'nk 7/11/2003 18:45'!
couldHaveRoundedCorners
	^ false! !

!ConnectionMorph methodsFor: 'geometry' stamp: 'FernandoOlivero 4/14/2010 14:24'!
curveBounds

	^(Rectangle encompassing: self contourPoints)
		expandBy: (self borderWidth + 4.0)! !

!ConnectionMorph methodsFor: 'editing' stamp: 'FernandoOlivero 5/31/2011 11:21'!
curveHandleClass 
	^ NCCurveHandleMorph! !

!ConnectionMorph methodsFor: 'geometry testing' stamp: 'nk 1/13/2004 17:28'!
curveInfoNearest: aPoint 
	"Answer the index of the segment nearest aPoint, along with the closest point, its distance, and the parametric value. "

	| closestPoint minDist minT segmentIndex |
	closestPoint := minDist := nil.
	self segments withIndexDo: 
			[:seg :i | 
			seg lineSegmentsWithParametricValueDo: 
					[:p1 :p2 :t1 :t2 | 
					| curvePoint dist |
					curvePoint := aPoint nearestPointOnLineFrom: p1 to: p2.
					dist := curvePoint dist: aPoint.
					(closestPoint isNil or: [dist < minDist]) 
						ifTrue: 
							[closestPoint := curvePoint.
							minDist := dist.
							segmentIndex := i.
							minT := (p1 = p2) ifTrue: [ t1 ] ifFalse: [ t1 interpolateTo: t2 at: (curvePoint dist: p1) / (p1 dist: p2)] ]]].
	^NCLineCurveInfo new 
		line: self
		targetPoint: aPoint
		segmentIndex: segmentIndex
		closestPoint: closestPoint
		minDist: minDist
		minT: minT! !

!ConnectionMorph methodsFor: 'editing' stamp: 'nk 8/20/2003 23:36'!
curveSegmentAt: n 
	^(self vertices at: n) + (self vertices at: (n + 1 min: vertices size)) / 2! !

!ConnectionMorph methodsFor: 'editing' stamp: 'FernandoOlivero 4/12/2010 00:40'!
curveSegmentAt: n put: aPoint
	| delta newVerts |
	(n between: 2 and: vertices size - 1) ifFalse: [ ^false ].
	delta := (self curveSegmentAt: n) - aPoint.
	newVerts := vertices copyFrom: n to: n + 1.
	delta := aPoint - newVerts average.
	newVerts := newVerts + delta.
	self setVertices: (vertices copyReplaceFrom: n to: n + 1 with: newVerts).
	^true
! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 4/12/2010 00:40'!
curveVertexAt: n
	"Answer the point on the visible curve corresponding to the given vertex."
	| index seg |
	index := (n min: vertices size) max: 1.
	(smoothCurve not  or: [ index = 1 or: [ (index = vertices size) ]]) ifTrue: [ ^vertices at: index ].
	seg := (self segments select: [ :ea | ea isBezier2Segment ]) at: index - 1
		ifAbsent: [ ^vertices first ].
	^seg valueAt: (seg start dist: seg via) / seg length! !

!ConnectionMorph methodsFor: 'editing' stamp: 'FernandoOlivero 4/12/2010 00:40'!
curveVertexAt: index put: aPoint
	"Set the point on the visible curve corresponding to the given vertex."
	| seg error actual attempts |
	(index between: 1 and: vertices size) ifFalse: [ ^false ].
	(smoothCurve not  or: [ index = 1 or: [ (index = vertices size) ]])
		ifTrue: [ self verticesAt: index put: aPoint. ^true ].
	attempts := 0.
	[attempts < 10] whileTrue: [
		seg := (self segments select: [ :ea | ea isBezier2Segment ]) at: index - 1 ifAbsent: [ ^false ].
		actual := seg valueAt: (seg start dist: seg via) / seg length.
		error := aPoint - actual.
		error r < 1 ifTrue: [ ^true ].
		self verticesAt: index put: (vertices at: index) + error.
		attempts := attempts + 1.
	].
	^false! !

!ConnectionMorph methodsFor: 'appearance' stamp: 'carlaGriggio 7/5/2010 03:55'!
dashedBorder: dashed
	borderDashSpec := dashed ! !

!ConnectionMorph methodsFor: 'appearance' stamp: 'carlaGriggio 7/5/2010 04:01'!
dashedLine: aBoolean
	| dashed |
	aBoolean ifTrue: [ dashed := { self lineWidth * 4 . self lineWidth * 3 . Color transparent . 0} ].
	self dashedBorder: dashed.	
	! !

!ConnectionMorph methodsFor: 'arrows' stamp: 'FernandoOlivero 5/31/2011 11:20'!
defaultArrow
	^ NCLineArrowGlyph noArrow! !

!ConnectionMorph methodsFor: 'initialization' stamp: 'FernandoOlivero 5/31/2011 13:07'!
defaultBorderColor
	^ Color black! !

!ConnectionMorph methodsFor: 'initialization' stamp: 'FernandoOlivero 5/31/2011 13:07'!
defaultBorderWidth
	^ 1! !

!ConnectionMorph methodsFor: 'appearance' stamp: 'FernandoOlivero 4/14/2010 16:45'!
doesBevels
	^false! !

!ConnectionMorph methodsFor: 'drawing' stamp: 'carlaGriggio 7/5/2010 04:42'!
drawDashedBorderOn: aCanvas usingEnds: anArray 
	"Display my border on the canvas. NOTE: mostly copied from  
	drawBorderOn:"
	| bevel topLeftColor bottomRightColor bigClipRect lineColor segmentOffset |

	bevel := false.
	"Border colors for bevelled effects depend on CW ordering of  
	vertices"
	lineColor  == #raised
		ifTrue: [topLeftColor := color lighter.
			bottomRightColor := color darker.
			bevel := true].
	lineColor  == #inset
		ifTrue: [topLeftColor := owner colorForInsets darker.
			bottomRightColor := owner colorForInsets lighter.
			bevel := true].
	bigClipRect := aCanvas clipRect expandBy: self borderWidth + 1 // 2.
	segmentOffset := (borderDashSpec fourth) asFloat.
	self
		lineSegmentsDo: [:p1 :p2 | | p2i p1i | 
			
			p1i := p1 asIntegerPoint.
			p2i := p2 asIntegerPoint.
			lineColor := Color black.
					 aCanvas
								line: p1
								to: p2
								width: lineWidth 
								color: lineColor
								dashLength: borderDashSpec first
								secondColor: borderDashSpec third
								secondDashLength: borderDashSpec second
								startingOffset: segmentOffset]! !

!ConnectionMorph methodsFor: 'drawing' stamp: 'FernandoOlivero 4/14/2010 15:32'!
drawOn: aCanvas 
	| ballonCanvas isShadow |
	ballonCanvas := aCanvas asBalloonCanvas.
	ballonCanvas
		aaLevel: 4;
		deferred: true.
	isShadow := aCanvas isShadowDrawing .
	smoothCurve 
		ifTrue: 
				[self 
					drawSmoothCurveOnAACanvas: ballonCanvas
					canvas: aCanvas
					isShadow: isShadow]
		ifFalse: 
				[self 
					drawSegmentedCurveOnAACanvas: ballonCanvas
					canvas: aCanvas
					isShadow: isShadow].
	ballonCanvas flush.
		! !

!ConnectionMorph methodsFor: 'drawing' stamp: 'FernandoOlivero 5/31/2011 12:44'!
drawSegmentedCurveOnAACanvas: aaCanvas canvas: aCanvas isShadow: isShadow 
	| c bw bc |
	c := isShadow ifTrue: [aCanvas shadowColor] ifFalse: [self color ].
	bw := self borderWidth.
	bc := isShadow ifTrue: [aCanvas shadowColor] ifFalse: [self borderColor].
	bw > (self lineWidth / 2) 
		ifTrue: 
			[c := nil.
			bw := (self lineWidth / 2) max: 1 ].
	self contours.
	(contours anySatisfy: [ :ctr | ctr isEmpty ]) ifTrue: [ ^self ].
	borderDashSpec ifNil:[aaCanvas 
		drawPolygon: contours first , contours third
		fillStyle: c
		borderWidth: bw
		borderColor: bc.]
	ifNotNil:[ self drawDashedBorderOn: aCanvas usingEnds: self vertices ].
	aaCanvas 
		drawGeneralBezierShape: { 
				contours second.
				{ 
					contours third first.
					contours third first.
					contours first last}.
				contours fourth.
				{ 
					contours first first.
					contours first first.
					contours third last}}
		color: c
		borderWidth: bw
		borderColor: bc.

	! !

!ConnectionMorph methodsFor: 'drawing' stamp: 'FernandoOlivero 5/31/2011 12:45'!
drawSmoothCurveOnAACanvas: aaCanvas canvas: aCanvas isShadow: isShadow 
	aaCanvas 
		drawGeneralBezierShape: self contours
		color: (isShadow ifTrue: [aCanvas shadowColor] ifFalse: [self color ])
		borderWidth: self borderWidth
		borderColor: (isShadow 
				ifTrue: [aCanvas shadowColor]
				ifFalse: [self borderColor])
! !

!ConnectionMorph methodsFor: 'geometry' stamp: 'FernandoOlivero 4/12/2010 00:40'!
extent: newExtent 
	"Not really advisable, but we can preserve most of the geometry if we don't
	shrink things too small."
	| safeExtent center |
	self changed.
	center := self referencePosition.
	safeExtent := newExtent max: 20@20.
	self setVertices: (vertices collect:
		[:p | p - center * (safeExtent asFloatPoint / (bounds extent max: 1@1)) + center])! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 5/31/2011 12:46'!
fillStyle
	Transcript show: 'fillStyle';cr.
	^ self color ! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 5/31/2011 12:57'!
fillStyle: aColor 
	Transcript show: 'fillStyle: ';cr.
	^ self color: aColor .! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'nk 7/11/2003 17:49'!
firstVertex
	^vertices first! !

!ConnectionMorph methodsFor: 'connecting' stamp: 'carlaGriggio 12/2/2010 14:34'!
from: origin to: destination 

	self vertices: {origin position . destination position}.
	origin attachTailOf: self .
	destination attachHeadOf: self. 
	self connectionPoints: {origin . destination }.
	self updateView.! !

!ConnectionMorph methodsFor: 'geometry' stamp: 'FernandoOlivero 4/12/2010 00:40'!
fullBounds
	^fullBounds ifNil: [
		self computeBounds.
		fullBounds := self outerBounds ].! !

!ConnectionMorph methodsFor: 'arrows' stamp: 'FernandoOlivero 4/14/2010 14:25'!
fullLineWidth
	| bw bc |
	bw := 0.
	bc := self borderColor. 
	bc isTransparent not ifTrue: [ bw := self borderWidth].
	^self lineWidth + (2 * bw) + 2! !

!ConnectionMorph methodsFor: 'arrows' stamp: 'carlaGriggio 7/5/2010 04:04'!
hasArrows
	^(self arrows includes: nil) not! !

!ConnectionMorph methodsFor: 'updating' stamp: 'FernandoOlivero 4/20/2010 07:16'!
hasMouseFocus
	^ self activeHand mouseFocus = self ! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 4/20/2010 06:03'!
headConnectionPoint 
	^ connectionPoints second 
	! !

!ConnectionMorph methodsFor: 'private' stamp: 'carlaGriggio 11/12/2010 00:37'!
headConnectionPointCenter
	^self headConnectionPoint center ! !

!ConnectionMorph methodsFor: 'rotate scale' stamp: 'nk 7/11/2003 18:48'!
heading: newHeading
	"Set the receiver's heading (in eToy terms).
	Note that polygons never use flex shells."
	self rotationDegrees: newHeading.! !

!ConnectionMorph methodsFor: 'updating' stamp: 'FernandoOlivero 4/20/2010 06:48'!
iconsSpecsOnClick
	^ {'move'}! !

!ConnectionMorph methodsFor: 'initialization' stamp: 'FernandoOlivero 5/31/2011 13:12'!
initializeWithVertices: verts lineWidth: w lineColor: c borderStyle: aBorderStyle
	connectionPoints := Array new:2.
	smoothCurve := false.
	submorphs := #().
	bounds := 0@0 extent: 0@0.
	lineWidth := w.
	borderWidth := aBorderStyle width .
	borderColor := aBorderStyle color. 
	color := c .
	self vertices: verts.
	self makeNoArrows.
! !

!ConnectionMorph methodsFor: 'geometry' stamp: 'nk 8/4/2003 18:06'!
innerBounds
	^self bounds! !

!ConnectionMorph methodsFor: 'editing' stamp: 'nk 8/18/2003 11:10'!
insertVertexAfterEndAt: position
	"insert another vertex, before first"

	self setVertices: (self vertices copyWith: position) asArray.
! !

!ConnectionMorph methodsFor: 'editing' stamp: 'nk 8/20/2003 15:48'!
insertVertexBeforeStartAt: position
	"insert another vertex, before first"

	self setVertices: ({ position }, self vertices) asArray.
! !

!ConnectionMorph methodsFor: 'editing' stamp: 'nk 1/14/2004 21:53'!
interiorCurveSegmentAt: n put: aPoint
	^self curveSegmentAt: n put: aPoint
! !

!ConnectionMorph methodsFor: 'editing' stamp: 'nk 1/14/2004 22:06'!
interiorCurveVertexAt: index put: aPoint
	(index = 1 or: [ index = vertices size ]) ifTrue: [ ^true ].
	^self curveVertexAt: index put: aPoint! !

!ConnectionMorph methodsFor: 'geometry testing' stamp: 'FernandoOlivero 4/12/2010 00:40'!
intersectionsWith: aRectangle
	"Answer a Set of points where the given Rectangle intersects with me.
	Ignores arrowForms."

	| retval |
	retval := IdentitySet new: 4.
	(self bounds intersects: aRectangle) ifFalse: [^ retval].

	self segmentsDo: [ :seg |
		aRectangle lineSegmentsDo: [ :rp1 :rp2 |
			retval addAll: (seg intersectionsWithLineFrom: rp1 to: rp2) ] ].

	^retval
! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 4/12/2010 00:40'!
isCurve
	^smoothCurve ifNil: [ smoothCurve := false ]! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'nk 7/11/2003 17:49'!
lastVertex
	^vertices last! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 5/31/2011 13:16'!
lineColor

	^self color! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 5/31/2011 13:16'!
lineColor: newColor
	self color: newColor
! !

!ConnectionMorph methodsFor: 'geometry-curves' stamp: 'FernandoOlivero 4/12/2010 00:40'!
lineSegments
	| segs |
	segs := OrderedCollection new.
	self lineSegmentsDo: [ :p1 :p2 | segs add: (LineSegment from: p1 to: p2) ].
	^segs! !

!ConnectionMorph methodsFor: 'geometry-curves' stamp: 'nk 7/11/2003 18:19'!
lineSegmentsDo: aBlock
	self segmentsDo: [ :seg | seg lineSegmentsDo: aBlock ]! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'nk 7/18/2003 14:30'!
lineWidth
	^lineWidth! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 4/14/2010 00:18'!
lineWidth: aNumber 
	| ratio oldWidth |
	oldWidth := self fullLineWidth.
	lineWidth := aNumber.
	ratio := self fullLineWidth / oldWidth.
	self arrows do: [:a | a scale: (a scale * ratio) asPoint].
	self computeBounds! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 4/20/2010 07:18'!
lostMouseFocus
	| fillStyle |
	fillStyle  := self backgroundColor .
	self fillStyle:  fillStyle.
! !

!ConnectionMorph methodsFor: 'arrows' stamp: 'FernandoOlivero 4/14/2010 16:45'!
makeBackArrow
	self arrowNames: #(basicArrow noArrow)! !

!ConnectionMorph methodsFor: 'arrows' stamp: 'FernandoOlivero 4/14/2010 16:46'!
makeBothArrows
	self arrowNames: #( basicArrow basicArrow)! !

!ConnectionMorph methodsFor: 'arrows' stamp: 'FernandoOlivero 4/14/2010 16:46'!
makeForwardArrow
	self arrowNames: #( noArrow basicArrow)! !

!ConnectionMorph methodsFor: 'arrows' stamp: 'FernandoOlivero 4/14/2010 16:46'!
makeNoArrows
	self arrowNames: #( noArrow noArrow)! !

!ConnectionMorph methodsFor: 'geometry' stamp: 'FernandoOlivero 4/12/2010 00:40'!
midpoint
	"Answer the midpoint along my segments"
	| middle |
	middle := 0.
	self lineSegmentsDo: [ :a :b | middle := middle + (a dist: b) ].
	middle < 2 ifTrue: [ ^ self center ].
	middle := middle / 2.
	self lineSegmentsDo: [ :a :b | | dist |
		dist := (a dist: b).
		middle < dist
			ifTrue: [ ^(a + ((b - a) * (middle / dist))) asIntegerPoint ].
		middle := middle - dist.
	].
	self error: 'can''t happen'! !

!ConnectionMorph methodsFor: 'private' stamp: 'FernandoOlivero 4/12/2010 00:40'!
nextDuplicateVertexIndex
	vertices
		doWithIndex: [:vert :index | ((index between: 2 and: vertices size - 1)
					and: [| epsilon v1 v2 | 
						v1 := vertices at: index - 1.
						v2 := vertices at: index + 1.
						epsilon := ((v1 x - v2 x) abs max: (v1 y - v2 y) abs)
									// 32 max: 1.
						vert
							onLineFrom: v1
							to: v2
							within: epsilon])
				ifTrue: [^ index]].
	^ 0! !

!ConnectionMorph methodsFor: 'geometry' stamp: 'nk 7/11/2003 17:49'!
nextToFirstPoint
	^vertices second! !

!ConnectionMorph methodsFor: 'geometry' stamp: 'nk 7/11/2003 17:48'!
nextToLastPoint
	^vertices at: vertices size - 1! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 4/14/2010 14:09'!
oldBorderWidth: anInteger 
	| ratio newWidth oldWidth borderColor borderWidth |
	oldWidth := self fullLineWidth.
	anInteger > 0 ifTrue: [borderColor ifNil: [borderColor := Color black]].
	newWidth := ((anInteger max: 0) min: self lineWidth / 2) asInteger.
	borderWidth := newWidth.
	ratio := self fullLineWidth / oldWidth.
	self arrows do: [:a | a scale: (a scale * ratio) asPoint].
	self computeBounds! !

!ConnectionMorph methodsFor: 'geometry' stamp: 'nk 8/22/2003 23:41'!
outerBounds
	^self curveBounds! !

!ConnectionMorph methodsFor: 'geometry-curves' stamp: 'nk 12/28/2003 15:42'!
outsideBezierPoints
	"Answer the nVertices + 1 *6 points that are the boundary points for two sets of bezier curves that define my outer bounds."

	| npts a b halfWidth normal ptsA ptsB tan1 tan2 angle1 angle2 halfAngle midAngle r delta |
	npts := self segments size * 3.
	ptsA := Array new: npts.
	ptsB := Array new: npts.
	a := 1.
	b := npts.
	halfWidth := self lineWidth * 0.5.
	self segmentsDo: 
			[:seg | 
			tan1 ifNil: 
					[tan1 := seg tangentAtStart.
					tan1 isZero ifTrue: [tan1 := 0.0 @ 1.0]].
			angle1 := tan1 negated theta.
			tan2 := seg tangentAtEnd.
			tan2 isZero ifTrue: [tan2 := 0.0 @ 1.0].
			angle2 := tan2 theta.

			"from end"
			normal := tan1 normal * halfWidth.
			ptsA at: a put: seg start - normal.
			ptsB at: b put: seg start + normal.
			a := a + 1.
			b := b - 1.
			seg isBezier2Segment 
				ifTrue: 
					["via"

					halfAngle := (angle1 - angle2) / 2.0.
					halfAngle abs < 4.0e-5 ifTrue: [halfAngle := 4.0e-5].
					midAngle := angle2 + halfAngle.
					r := halfWidth / halfAngle sin.
					r := r min: halfWidth * 6.0 max: halfWidth * -6.0.
					delta := (r * midAngle cos) @ (r * midAngle sin).
					ptsA at: a put: seg via - delta.
					ptsB at: b put: seg via + delta.
					a := a + 1.
					b := b - 1].

			"to end"
			normal := tan2 normal * halfWidth.
			ptsA at: a put: seg end - normal.
			ptsB at: b put: seg end + normal.
			a := a + 1.
			b := b - 1.
			seg isBezier2Segment 
				ifFalse: 
					[ptsA at: a put: seg end - normal.
					ptsB at: b put: seg end + normal.
					a := a + 1.
					b := b - 1].
			tan1 := tan2].
	segments last isBezier2Segment 
		ifFalse: 
			[| csize |
			csize := ptsA size.
			ptsA at: csize - 1 put: (ptsA at: csize - 2).
			ptsB at: 2 put: (ptsB at: 3)].
	^{ 
		ptsA.
		ptsB}! !

!ConnectionMorph methodsFor: 'geometry-curves' stamp: 'nk 8/16/2004 13:42'!
outsidePoints
	"Answer the nVertices *2 points that are the boundary points for two sets of lines that define my outer bounds."

	| npts a b halfWidth normal ptsA ptsB tan1 tan2 angle1 angle2 halfAngle midAngle r delta arrowVertices |
	smoothCurve ifTrue: [^self outsideBezierPoints].
	arrowVertices := self arrowVertices.
	npts := arrowVertices size.
	ptsA := Array new: npts.
	ptsB := Array new: npts.
	a := 1.
	b := npts.
	halfWidth := self lineWidth * 0.5.
	2 to: arrowVertices size
		do: 
			[:i | 
			| v1 v2 v3 |
			v1 := arrowVertices at: i - 1.
			v2 := arrowVertices at: i.
			tan1 := v2 - v1.
			tan1 isZero 
				ifTrue: 
					[tan1 := i + 1 > arrowVertices size 
								ifTrue: [v2 - (arrowVertices at: i - 1)]
								ifFalse: [(arrowVertices at: i + 1) - v1]].

			tan1 isZero ifTrue: [ tan1 := 0.0 @ 1.0 ].

			angle1 := tan1 theta.

			"from end"
			a = 1 
				ifTrue: 
					[normal := tan1 normal * halfWidth.
					ptsA at: a put: v1 - normal.
					ptsB at: b put: v1 + normal.
					a := a + 1.
					b := b - 1].
			b = 1 
				ifTrue: 
					["to end"

					normal := tan1 normal * halfWidth.
					ptsA at: a put: v2 - normal.
					ptsB at: b put: v2 + normal.
					a := a + 1.
					b := b - 1]
				ifFalse: 
					[v3 := arrowVertices at: i + 1.
					tan2 := v2 - v3.
					angle2 := tan2 theta.

					"via"
					halfAngle := (angle1 - angle2) / 2.0.
					halfAngle abs < 0.004 ifTrue: [halfAngle := 0.004].
					midAngle := angle2 + halfAngle.
					r := halfWidth / halfAngle sin.
					r := r min: halfWidth * 6 max: halfWidth * -6.
					delta := (r * midAngle cos) @ (r * midAngle sin).
					ptsA at: a put: v2 + delta.
					ptsB at: b put: v2 - delta.
					a := a + 1.
					b := b - 1]].
	^{ 
		ptsA.
		ptsB}! !

!ConnectionMorph methodsFor: 'private' stamp: 'nk 12/27/2003 11:23'!
privateMoveBy: delta
	super privateMoveBy: delta.
	(self valueOfProperty: #referencePosition) ifNotNilDo:
		[:oldPos | self setProperty: #referencePosition toValue: oldPos + delta].
	self setVertices: (vertices collect: [:p | p + delta]).
! !

!ConnectionMorph methodsFor: 'geometry' stamp: 'FernandoOlivero 4/12/2010 00:40'!
reduceVertices
	"Reduces the vertices size, when 3 vertices are on the same line with a 
	little epsilon. Based on code by Steffen Mueller"
	| dup |
	[ (dup := self nextDuplicateVertexIndex) > 0 ] whileTrue: [
		self setVertices: (vertices copyWithoutIndex: dup)
	].
	^vertices size.! !

!ConnectionMorph methodsFor: 'rotate scale' stamp: 'nk 12/27/2003 11:23'!
referencePosition 
	"Return the current reference position of the receiver"
	^ self valueOfProperty: #referencePosition ifAbsent: [ self midpoint ]
! !

!ConnectionMorph methodsFor: 'geometry' stamp: 'FernandoOlivero 4/12/2010 00:40'!
removeShortEndSegmentsStepping: stepBlock
	| v1 v2 n minLength |
	minLength := 30.
	
	(n := self vertices size) > 2 ifTrue: [
		stepBlock value.
		v1 := self vertexAt: 1.
		v2 := self vertexAt: 2.
		(v1 dist: v2) < minLength ifTrue: [ self removeVertex: v2 ].
	].
	(n := self vertices size) > 2 ifTrue: [
		stepBlock value.
		v1 := self vertexAt: n.
		v2 := self vertexAt: n-1.
		(v1 dist: v2) < minLength ifTrue: [ self removeVertex: v2 ].
	].
	self vertices size > 2 ifTrue: [ self reduceVertices ].
	stepBlock value.
! !

!ConnectionMorph methodsFor: 'editing' stamp: 'nk 10/19/2003 16:57'!
removeVertex: aVertex
	^self setVertices: (self vertices copyWithout: aVertex)! !

!ConnectionMorph methodsFor: 'rotate scale' stamp: 'FernandoOlivero 4/12/2010 00:40'!
rotationCenter
	"Return the rotation center of the receiver. The rotation center defines the relative offset inside the receiver's bounds for locating the reference position."
	| refPos |
	refPos := self valueOfProperty: #referencePosition
		ifAbsent: [^ 0.5@0.5].
	^ (refPos - self bounds origin) / self bounds extent asFloatPoint! !

!ConnectionMorph methodsFor: 'rotate scale' stamp: 'FernandoOlivero 4/12/2010 00:40'!
rotationCenter: aPointOrNil
	"Set the new rotation center of the receiver. The rotation center defines the relative offset inside the receiver's bounds for locating the reference position."
	| box |
	aPointOrNil isNil
		ifTrue: [self removeProperty: #referencePosition]
		ifFalse: [box := self bounds.
				self setProperty: #referencePosition
					toValue: box origin + (aPointOrNil * box extent)]
! !

!ConnectionMorph methodsFor: 'rotate scale' stamp: 'nk 7/11/2003 18:56'!
rotationDegrees

	^ self forwardDirection! !

!ConnectionMorph methodsFor: 'rotate scale' stamp: 'FernandoOlivero 4/12/2010 00:40'!
rotationDegrees: degrees 
	| flex center |
	center := self referencePosition.
	flex := (MorphicTransform offset: center negated)
			withAngle: (degrees - self forwardDirection) degreesToRadians.
	self setVertices: (vertices collect: [:v | (flex transform: v) - flex offset]).
	self forwardDirection: degrees.

! !

!ConnectionMorph methodsFor: 'rotate scale' stamp: 'nk 9/4/2004 07:41'!
scale
	^self valueOfProperty: #scaleFactor ifAbsent: [ 1.0 ]
! !

!ConnectionMorph methodsFor: 'rotate scale' stamp: 'nk 9/4/2004 11:54'!
scale: scaleFactor 
	| flex center ratio |
	ratio := self scaleFactor / scaleFactor.
	self lineWidth: self lineWidth / ratio.
	self borderWidth: self borderWidth / ratio.
	center := self referencePosition.
	flex := (MorphicTransform offset: center negated)
				withScale: ratio.
	self
		setVertices: (vertices
				collect: [:v | (flex transform: v)
						- flex offset]).
	super scale: scaleFactor.! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'nk 12/28/2003 16:53'!
segments
	^segments ifNil: 
			[segments := self computeSegments segments do: [:ea | ea roundTo: 0.001]]! !

!ConnectionMorph methodsFor: 'geometry-curves' stamp: 'nk 8/19/2003 10:34'!
segmentsDo: segmentBlock 
	"Emit a sequence of LineSegment subinstances into segmentBlock"

	self segments do: segmentBlock! !

!ConnectionMorph methodsFor: 'editing' stamp: 'FernandoOlivero 5/31/2011 13:04'!
setVertices: newVertices

	| proposedVertices |
	vertices = newVertices ifTrue: [ ^self ].

	proposedVertices := Array streamContents: [ :s |
		s nextPut: newVertices first asFloatPoint.
		newVertices overlappingPairsDo: [ :v1 :v2 |
			(v1 dist: v2) >= 2 ifTrue: [ s nextPut: v2 asFloatPoint ] ] ].
	
	proposedVertices := newVertices.
	
	proposedVertices size < 2 ifTrue: [ self error  ].

	proposedVertices size = 2 ifTrue: [
		(newVertices first dist: newVertices last) < 2 ifTrue: [
			proposedVertices := { newVertices first. newVertices first + (2@2) }] ].
	vertices = proposedVertices ifTrue: [ ^self ].
	vertices := proposedVertices.
	self computeBounds! !

!ConnectionMorph methodsFor: 'editing' stamp: 'nk 7/11/2003 21:57'!
straighten
	self setVertices: { vertices first . vertices last }! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 4/20/2010 06:03'!
tailConnectionPoint 
	^ connectionPoints first  
	! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'carlaGriggio 11/12/2010 00:36'!
tailConnectionPointCenter
	^ self tailConnectionPoint center
	! !

!ConnectionMorph methodsFor: 'connecting' stamp: 'FernandoOlivero 4/20/2010 09:22'!
to: destination 
	self from: self tailConnectionPoint  to: destination ! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'FernandoOlivero 4/12/2010 00:40'!
toggleSmoothing

	smoothCurve := smoothCurve not.
	self computeBounds! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'nk 8/25/2003 16:21'!
totalLength
	"Answer the full length of my segments. Can take a long time if I'm curved."
	^self segments detectSum: [ :seg | seg length ]! !

!ConnectionMorph methodsFor: 'rotate scale' stamp: 'nk 1/23/2004 14:57'!
transformedBy: aTransform
	self setVertices: (self vertices collect:[:v| aTransform localPointToGlobal: v])! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'nk 9/4/2004 07:19'!
unrotatedWidth
	^self lineWidth! !

!ConnectionMorph methodsFor: 'arrows' stamp: 'nk 12/28/2003 16:13'!
updateArrowContours
	"Open the arrows for my line width.
	Set contours[2] and contours[4] with arrow contours.
	Put the arrow join points into arrowJoints."

	| transform lw |
	lw := (smoothCurve not and: [self lineWidth <= 0]) 
				ifTrue: [0]
				ifFalse: [self lineWidth].
	self arrows first openForLineWidth: lw.
	arrows second openForLineWidth: lw.
	transform := (MatrixTransform2x3 
				withAngle: (vertices second - vertices first) negated theta 
						radiansToDegrees + 90.0) 
					offset: vertices first.
	contours at: 4 put: (arrows first contourPointsTransformedBy: transform).
	self arrowJoints at: 1
		put: (transform transformPoint: arrows first joinPoint).
	transform := (MatrixTransform2x3 
				withAngle: (vertices last - vertices nextToLast) theta radiansToDegrees 
						+ 90.0) 
					offset: vertices last.
	contours at: 2 put: (arrows second contourPointsTransformedBy: transform).
	self arrowJoints at: 2
		put: (transform transformPoint: arrows second joinPoint)! !

!ConnectionMorph methodsFor: 'updating' stamp: 'carlaGriggio 11/12/2010 00:37'!
updateHeadVertex
	self verticesAt: vertices size put: self headConnectionPointCenter .
! !

!ConnectionMorph methodsFor: 'updating' stamp: 'carlaGriggio 11/12/2010 10:53'!
updateTailVertex
	self verticesAt: 1 put: self tailConnectionPointCenter ! !

!ConnectionMorph methodsFor: 'updating' stamp: 'carlaGriggio 12/2/2010 14:41'!
updateView 
	self
		updateTailVertex ;
		updateHeadVertex;
		changed! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'nk 7/11/2003 19:50'!
vertexAt: n
	^vertices at: (n min: vertices size).! !

!ConnectionMorph methodsFor: 'drawing' stamp: 'nk 7/17/2003 17:54'!
vertexPairsDo: aBlock 
	"Emit pairs of start/end points into aBlock"
	vertices overlappingPairsDo: aBlock! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'nk 7/11/2003 15:08'!
vertices
	^ vertices! !

!ConnectionMorph methodsFor: 'accessing' stamp: 'carlaGriggio 12/2/2010 14:13'!
vertices: anArray 
	self setVertices: anArray .! !

!ConnectionMorph methodsFor: 'editing' stamp: 'FernandoOlivero 4/12/2010 00:40'!
verticesAt: n put: newPoint
	| index |
	index := (n min: vertices size) max: 1.
	self setVertices: (vertices copy at: index put: newPoint; yourself).
! !

ConnectionMorph subclass: #HandledConnectionMorph
	instanceVariableNames: 'handles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MinimalConnectors-Connections'!

!HandledConnectionMorph methodsFor: 'editing' stamp: 'carlaGriggio 8/16/2010 04:35'!
addHandles
	self addAllMorphs: self handles! !

!HandledConnectionMorph methodsFor: 'editing' stamp: 'carlaGriggio 8/16/2010 04:36'!
click: event 
	| clickedPosition clickedHandle endPointHandles headHandle tailHandle handleSpec handle epsilon |
	event hand mouseFocus ~= self ifTrue:[ ^ self ].
	clickedPosition := event position.
	endPointHandles := self endPointHandles .
	headHandle := endPointHandles second.
	tailHandle := endPointHandles first .
	epsilon := 13.
	( tailHandle notNil and:[ ( vertices first dist: clickedPosition) < epsilon ] ) ifTrue:[ self error  ].
	( headHandle notNil and:[ (vertices second dist: clickedPosition) < epsilon ] ) ifTrue:[
		handle := GMConnectionHandle fromSpec: headHandle  .
		handle connection: self.
		self pampas addMorph: handle.
		handle center: vertices second.
		handle mouseDown: event  ].
	
	
! !

!HandledConnectionMorph methodsFor: 'event handling' stamp: 'carlaGriggio 8/16/2010 04:41'!
dragHandleStarted: aConnectionHandle 
	self fillStyle: Color lightGray .
	! !

!HandledConnectionMorph methodsFor: 'event handling' stamp: 'carlaGriggio 8/16/2010 04:41'!
dragHandleStoped: aGMConnectionHandle 
	| error |
	self flag:'solo tenemos herencia por ahora...por eso lo hardcodeo'.
	aGMConnectionHandle delete.
	aGMConnectionHandle isConnected ifTrue:[
		error := false.
		[ self tailConnectionPoint expanderShape changeSuperclassTo: aGMConnectionHandle connectionPoint expanderShape ] on: Error do:[:err| error := true. err pass   ].
		error not ifTrue:[ 	self to: aGMConnectionHandle connectionPoint] ].
	self fillStyle: self backgroundColor .
	! !

!HandledConnectionMorph methodsFor: 'accessing' stamp: 'carlaGriggio 8/16/2010 04:41'!
endPointHandles
	^ self valueOfProperty: #endPointHandles ifAbsentPut:[ #(nil nil)].! !

!HandledConnectionMorph methodsFor: 'accessing' stamp: 'carlaGriggio 8/16/2010 04:41'!
endPointHandles: twoHandlesSpecs
	self setProperty:#endPointHandles toValue: twoHandlesSpecs .
	! !

!HandledConnectionMorph methodsFor: 'editing' stamp: 'carlaGriggio 8/16/2010 04:42'!
handleForEvent: anEvent 
	"Answer a NCCurveHandleMorph that can be used to adjust me at the 
	given point."
	^self handleForPosition: anEvent position addAllowed: anEvent shiftPressed! !

!HandledConnectionMorph methodsFor: 'editing' stamp: 'carlaGriggio 8/16/2010 04:42'!
handleForPosition: pos addAllowed: canAddVertex 
	"Answer a NCCurveHandleMorph that can be used to adjust me at the 
	given point."

	| v s curveInfo |
	curveInfo := self curveInfoNearest: pos.
	v := curveInfo vertexWithinProportion: 0.15
				andDistance: (40 max: self lineWidth / 2 + self borderWidth + 2).
	s := curveInfo closestBigSegment.
	v isZero 
		ifTrue: 
			[(canAddVertex or: [s = 1 or: [s = (vertices size - 1)]]) 
				ifTrue: 
					["Make a new vertex to edit"

					v := s + 1.
					self setVertices: (self vertices 
								copyReplaceFrom: v
								to: v - 1
								with: (Array with: pos))]
				ifFalse: 
					[^self curveHandleClass new 
						target: self
						arguments: { 
								s}
						getPointSelector: #curveSegmentAt:
						setPointSelector: #curveSegmentAt:put:]].
	^self curveHandleClass new 
		target: self
		arguments: { 
				v}
		getPointSelector: #curveVertexAt:
		setPointSelector: #curveVertexAt:put:! !

!HandledConnectionMorph methodsFor: 'arrows' stamp: 'carlaGriggio 8/16/2010 04:44'!
handles
	"Answer a collection of NCCurveHandleMorphs that can be used to adjust my vertices"
	| handles |
	handles := submorphs select: [ :ea | ea isCurveHandle ].
	handles size = vertices size ifTrue: [ ^handles ].

	^(1 to: vertices size) collect: [ :v |
		NCCurveHandleMorph new 
		target: self
		arguments: {  v}
		getPointSelector: #curveVertexAt:
		setPointSelector: #curveVertexAt:put:
		]! !

!HandledConnectionMorph methodsFor: 'initialization' stamp: 'carlaGriggio 8/16/2010 04:44'!
initializeInteraction 
	self addInteraction .
	self eventHandler addWindowKeyboardInteraction   .! !

!HandledConnectionMorph methodsFor: 'editing' stamp: 'carlaGriggio 8/16/2010 04:45'!
interiorHandleForEvent: anEvent 
	"Answer a NCCurveHandleMorph that can be used to adjust me at the 
	given point."
	^self interiorHandleForPosition: anEvent position addAllowed: anEvent shiftPressed! !

!HandledConnectionMorph methodsFor: 'editing' stamp: 'carlaGriggio 8/16/2010 04:45'!
interiorHandleForPosition: pos addAllowed: canAddVertex 
	| handle sel |
	handle := self handleForPosition: pos addAllowed: canAddVertex.
	sel := handle setPointSelector.
	handle setPointSelector: ('interiorC', (sel allButFirst)) asSymbol.
	^handle
! !

!HandledConnectionMorph methodsFor: 'editing' stamp: 'carlaGriggio 8/16/2010 04:47'!
removeHandles
	| handles |
	handles := submorphs select: [ :ea | ea isCurveHandle ].
	self removeAllMorphsIn:  handles.! !

BorderedMorph subclass: #SingleConnectionPointMorph
	instanceVariableNames: 'outConnections inConnections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MinimalConnectors-Connections'!

!SingleConnectionPointMorph methodsFor: 'private' stamp: 'carlaGriggio 8/13/2010 20:04'!
attachHeadOf: aConnector 
	(inConnections includes: aConnector) ifFalse:[ inConnections add: aConnector ].! !

!SingleConnectionPointMorph methodsFor: 'private' stamp: 'carlaGriggio 8/13/2010 21:27'!
attachTailOf: aConnector
	(outConnections includes: aConnector) ifFalse:[outConnections add: aConnector ].! !

!SingleConnectionPointMorph methodsFor: 'accessing' stamp: 'carlaGriggio 7/28/2010 11:34'!
close 
	inConnections copy do:#close.
	outConnections copy do:#close.
! !

!SingleConnectionPointMorph methodsFor: 'accessing' stamp: 'carlaGriggio 8/15/2010 22:51'!
connectTo: anotherConnectionPoint
	| connector |
	connector := self connectionClass from: self to: anotherConnectionPoint.
	^ connector ! !

!SingleConnectionPointMorph methodsFor: 'accessing' stamp: 'carlaGriggio 8/15/2010 22:53'!
connection
"This point will always have only one connection, refactors are still pending"
	^ self connections anyOne! !

!SingleConnectionPointMorph methodsFor: 'private' stamp: 'carlaGriggio 8/15/2010 22:51'!
connectionClass
	^self factory connectionClass! !

!SingleConnectionPointMorph methodsFor: 'private' stamp: 'carlaGriggio 8/12/2010 16:03'!
connectionIndexOf: aConnection
	^(self connections includes: aConnection) 
		ifTrue:[(self connections indexOf: aConnection) -1]! !

!SingleConnectionPointMorph methodsFor: 'accessing' stamp: 'carlaGriggio 7/28/2010 11:34'!
connections
	^ inConnections , outConnections ! !

!SingleConnectionPointMorph methodsFor: 'accessing' stamp: 'carlaGriggio 8/12/2010 16:47'!
connectionsSize
	^self connections size! !

!SingleConnectionPointMorph methodsFor: 'initialization' stamp: 'FernandoOlivero 5/31/2011 12:49'!
defaultBorderColor
	^Color transparent ! !

!SingleConnectionPointMorph methodsFor: 'visual properties' stamp: 'FernandoOlivero 5/31/2011 12:48'!
defaultColor
	^Color transparent  ! !

!SingleConnectionPointMorph methodsFor: 'private' stamp: 'carlaGriggio 8/13/2010 10:36'!
delta
	^"owner delta"10! !

!SingleConnectionPointMorph methodsFor: 'accessing' stamp: 'carlaGriggio 12/2/2010 14:41'!
dettachFrom: aConnector 
	|formerOwner|
	inConnections remove: aConnector ifAbsent:[ ].
	outConnections remove: aConnector ifAbsent:[].
	formerOwner := owner.
	"owner removeMorph: self."
	"formerOwner owner updateLayout."! !

!SingleConnectionPointMorph methodsFor: 'support' stamp: 'carlaGriggio 7/28/2010 12:18'!
factory
	^UMLFactory new! !

!SingleConnectionPointMorph methodsFor: 'testing' stamp: 'carlaGriggio 7/28/2010 11:34'!
hasConnections
	^ ( inConnections isEmpty and:[ outConnections isEmpty ] ) not! !

!SingleConnectionPointMorph methodsFor: 'accessing' stamp: 'carlaGriggio 7/28/2010 11:34'!
inConnections
	^ inConnections ! !

!SingleConnectionPointMorph methodsFor: 'initialization' stamp: 'carlaGriggio 7/28/2010 11:34'!
initialBounds
	^ 0@0 extent: 5@5.! !

!SingleConnectionPointMorph methodsFor: 'initialization' stamp: 'carlaGriggio 8/16/2010 04:05'!
initialize 
	super initialize .
	inConnections := OrderedCollection new.
	outConnections := OrderedCollection new.
	self bounds: self initialBounds.
	! !

!SingleConnectionPointMorph methodsFor: 'accessing' stamp: 'carlaGriggio 8/15/2010 22:53'!
oppositeConnectionPoint
	^self connection connectionPoints detect:[:cp | cp ~= self]! !

!SingleConnectionPointMorph methodsFor: 'accessing' stamp: 'carlaGriggio 7/28/2010 11:34'!
outConnections
	^ outConnections ! !

!SingleConnectionPointMorph methodsFor: 'updating' stamp: 'carlaGriggio 12/17/2010 02:34'!
updateConnections 
	"inConnections do:[:each| each updateHeadVertex ].
	outConnections do:[:each| each updateTailVertex ]."
	self connections do:[:conn | conn  updateView; updateLabel]
	 ! !

!SingleConnectionPointMorph methodsFor: 'updating' stamp: 'carlaGriggio 11/16/2010 13:23'!
updateConnectionsLabel
	self connections do:[:conn | conn  updateLabel.]! !

!SingleConnectionPointMorph methodsFor: 'updating' stamp: 'carlaGriggio 8/16/2010 05:15'!
updateFillStyle 
	self fillStyle: Color transparent 
	
! !

!SingleConnectionPointMorph methodsFor: 'updating' stamp: 'carlaGriggio 8/14/2010 03:10'!
updateView 
	self
		updateFillStyle ;
		updateConnections.
! !

!SingleConnectionPointMorph methodsFor: 'accessing' stamp: 'carlaGriggio 7/28/2010 11:34'!
visible: aBoolean 
	super visible: aBoolean .
	outConnections do:[:each| each visible: aBoolean ].
	inConnections do:[:each| each visible: aBoolean  ].
! !

!LineSegment methodsFor: '*MinimalConnectors-Connections' stamp: 'nk 8/23/2003 13:54'!
controlPoints
	^{start. end}! !

!LineSegment methodsFor: '*MinimalConnectors-Connections' stamp: 'nk 8/18/2003 11:28'!
controlPointsDo: aBlock
	aBlock value: start; value: end! !

!LineSegment methodsFor: '*MinimalConnectors-Connections' stamp: 'FernandoOlivero 4/13/2010 23:54'!
intersectionWith: anotherSegment
	"Copied from LineIntersections>>intersectFrom:to:with:to:"
	| det deltaPt alpha beta pt1Dir pt2Dir |
	pt1Dir := end - start.
	pt2Dir := anotherSegment end - anotherSegment start.
	det := (pt1Dir x * pt2Dir y) - (pt1Dir y * pt2Dir x).
	deltaPt := anotherSegment start - start.
	alpha := (deltaPt x * pt2Dir y) - (deltaPt y * pt2Dir x).
	beta := (deltaPt x * pt1Dir y) - (deltaPt y * pt1Dir x).
	det = 0 ifTrue:[^nil]. "no intersection"
	alpha * det < 0 ifTrue:[^nil].
	beta * det < 0 ifTrue:[^nil].
	det > 0 
		ifTrue:[(alpha > det or:[beta > det]) ifTrue:[^nil]]
		ifFalse:[(alpha < det or:[beta < det]) ifTrue:[^nil]].
	"And compute intersection"
	^start + (alpha * pt1Dir / (det@det))! !

!LineSegment methodsFor: '*MinimalConnectors-Connections' stamp: 'FernandoOlivero 4/13/2010 23:54'!
intersectionsWithLineFrom: e1 to: e2
	"Answer the set of intersections, if any"
	| intersection |
	intersection := self intersectionWith: (LineSegment from: e1 to: e2).
	^intersection ifNotNil: [ { intersection } ] ifNil: [ {} ].! !

!LineSegment methodsFor: '*MinimalConnectors-Connections' stamp: 'nk 8/18/2003 21:35'!
lineSegmentsWithParametricValueDo: aBlock
	"Evaluate aBlock with the receiver's line segments"
	aBlock value: start value: end value: 0.0 value: 1.0! !

!LineSegment methodsFor: '*MinimalConnectors-Connections' stamp: 'FernandoOlivero 4/13/2010 23:54'!
roundTo: quantum
	start := start roundTo: quantum.
	end := end roundTo: quantum.! !
ConnectionMorph initialize!
